/*

  
  Requirements:
    - Windows 98 (or Windows 95 + IE 4.0+)
    - Windows 2000 (or Windows NT 4.0 + IE 4.0+)


*/
#include <windows.h>
#include <Shobjidl.h>
#include "resource.h"
#include "taskbar.h"

HINSTANCE hInst;        // Cuurrent Instance..


HWND g_hDlg;
bool g_bVisible = true;


///////////////////////////////////////////////
// The Main Function.
///////////////////////////////////////////////
int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	hInst = hInstance;
	return (DialogBoxParam(hInst,"MyDialog",NULL,(DLGPROC)DlgProc,0));
}
 

////////////////////////////////////////////////////////
// Dialog Procdure.
///////////////////////////////////////////////////////
LRESULT DlgProc( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{ 
		case WM_COMMAND:	
		 switch (LOWORD(wParam))
		 {
		 case ID_CLOSE:
			 EndDialog(hDlg,IDOK);
			 break;	
		 case ID_TRY:
			 g_bVisible = !g_bVisible;
			 if (g_bVisible)
				 SetDlgItemText(hDlg,ID_TRY,"Hide");
			 else
				 SetDlgItemText(hDlg,ID_TRY,"Show");

			  ShowOnTaskbar (hDlg,g_bVisible );
			 break;
		 }
		  break;
		  
	default :
		return(FALSE);
	}
	return (TRUE);
}

////////////////////////////////////////////////////////
// The Procedure responsible for showing or hiding the windows
// From the Taskbar.
///////////////////////////////////////////////////////
int ShowOnTaskbar (HWND hWin, bool bVisible )
{

	HRESULT     hr;
	ITaskbarList *ShellTaskBar;

    CoInitialize(NULL);
    
	hr = CoCreateInstance(CLSID_TaskbarList,NULL,
             CLSCTX_INPROC_SERVER,IID_ITaskbarList,(void**)&ShellTaskBar);
	if ( SUCCEEDED ( hr ) )
	{
		ShellTaskBar->HrInit();
		if (bVisible)
		{
			ShellTaskBar->AddTab(hWin);
            ShellTaskBar->ActivateTab(hWin);
		}
		else
			ShellTaskBar->DeleteTab(hWin);
        
	ShellTaskBar->Release();
	}
	CoUninitialize();

      return 0;
	
 
}

